您的位置:首页 > 其它

【CUGBACM15级BC第9场 B】hdu 4994 Revenge of Nim

2017-09-15 20:53 351 查看

Revenge of Nim

[align=center]Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 822    Accepted Submission(s): 422
[/align]

[align=left]Problem Description[/align]

Nim is a mathematical game of strategy in which two players take turns removing objects from distinct heaps. On each turn, a player must remove at least one object, and may remove any number of objects
provided they all come from the same heap.

---Wikipedia

Today, Nim takes revenge on you. The rule of the game has changed a little: the player must remove the objects from the current head(first) heap. Only the current head heap is empty can the player start to remove from the new head heap. As usual, the player
who takes the last object wins.
 

[align=left]Input[/align]

The first line contains a single integer T, indicating the number of test cases.

Each test case begins with an integer N, indicating the number of heaps. Then N integer Ai follows, indicating the number of each heap successively, and the player must take objects in this order, from the first to the last.

[Technical Specification]

1. 1 <= T <= 100

2. 1 <= N <= 1 000

3. 1 <= Ai <= 1 000 000 000
 

[align=left]Output[/align]

For each test case, output “Yes” if the first player can always win, otherwise “No”.
 

[align=left]Sample Input[/align]

2
1
2
2
1 1

 

[align=left]Sample Output[/align]

Yes
No

 
题意:
有n 堆石子,从第一堆到最后一堆,每次可以取任意多个,但只能取同一堆的,最后取完的人赢,问先手能否胜利?
思路:

尼姆博奕的变形,应该来说比尼姆博奕要好理解。  这里当某一堆里石头个数为1时,无奈,此人只能把该堆取完。

当某一堆石头个数大于1时,此时此人可以根据后面所有堆是必胜态还是必败态来决定是把该堆取完让下一个人进行那个状态还是把该堆取完只剩一个,让自己进行那个状态。   所以不管后面如何变化,我们只要考虑第一次出现的大于1的堆之前有多少个大小为1的堆即可。因为谁先进入这个第一次出现的大于1的堆即可获得胜利
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
#define N 1100

int a
;
int main()
{
int T, n;
scanf("%d", &T);
while (T--)
{
scanf("%d", &n);
int flag = 0, ans = 0;
for (int i = 1; i <= n; i++)
{
scanf("%d", &a[i]);
if (a[i] > 1)
{
flag = 1;
}
if (!flag)
{
ans++;
}
}
if (!flag)
{
if (ans & 1)
{
printf("Yes\n");
}
else
{
printf("No\n");
}
}
else
{
if (ans & 1)
{
printf("No\n");
}
else
{
printf("Yes\n");
}
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  hdu 博弈